package com.isomorphic.atmosphere.client;

import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.json.client.JSONObject;

public class Atmosphere {

	public static class AtmosphereSocket {
		JavaScriptObject jsoSocket;
		public AtmosphereSocket(JavaScriptObject jsoSocket) {
			this.jsoSocket = jsoSocket;
		}
		public JavaScriptObject getAsJso() {
			return jsoSocket;
		}
	}
	
	public static AtmosphereSocket subscribe(Configurator configurator) {
		return new AtmosphereSocket(subscribe(configurator.asJsonObject(), configurator.getMessageHandler()));
	}
	
	private static native JavaScriptObject subscribe(JSONObject configurator,
			IAtmosphereMessageHandler atmosphereMessageHandler) /*-{
			
		// Subscribe
		parsed = JSON.parse(configurator);
		service = parsed.service==null?"unknown-service":parsed.service;
		channelId = parsed.channelId==null?"unknown-channelId":parsed.channelId;
		loc = parsed.moduleBaseUrl==null?"/":parsed.moduleBaseUrl;
		ptransport = parsed.transport==null?"unknown-transport":parsed.transport;
		pfallbackTransport = parsed.fallbackTransport==null?"unknown-fallbacktransport":parsed.fallbackTransport;
		request = { url: loc + service + "/" + channelId,
				contentType : "application/json",
				logLevel : "debug",
				transport : ptransport ,
				fallbackTransport: pfallbackTransport};

		request.onMessage = 
			$entry(function(response) {
                atmosphereMessageHandler.@com.isomorphic.atmosphere.client.IAtmosphereMessageHandler::onMessage(Ljava/lang/String;)(response.responseBody);
            });
		
		request.onOpen = function(response) {
			console.log("V1.1. Atmosphere connected using " + response.transport);
		};

		request.onError = function(response) {
			console.log("error in response!!!");
		};
		
		socket = $wnd.$.atmosphere;
		subSocket = socket.subscribe(request);
		return subSocket;
	}-*/;
	
	public static native void unsubscribe() /*-{
		$wnd.$.atmosphere.unsubscribe();
	}-*/;

	public static native void pushData(JavaScriptObject socket, JSONObject data) /*-{
		socket.push(data.toString());
	}-*/;
}
