package com.isomorphic.atmosphere.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.json.client.JSONObject;
import com.google.gwt.json.client.JSONString;
import com.google.gwt.user.client.rpc.IsSerializable;

public class Configurator implements IsSerializable {
	
	public static final String TRANSPORT_STREAMING = "streaming";
	public static final String TRANSPORT_WEBSOCKET = "websocket";
	public static final String TRANSPORT_LONG_POLLING = "long-polling";
	
	private String service;
	private String channelId;
	private String transport;
	private String fallbackTransport;
	public IAtmosphereMessageHandler messageHandler;

	public JSONObject asJsonObject() {
		JSONObject retVal = new JSONObject();
		retVal.put("moduleBaseUrl", new JSONString(GWT.getHostPageBaseURL()));
		retVal.put("service", new JSONString(service));
		retVal.put("channelId", new JSONString(channelId));
		retVal.put("transport", new JSONString(transport));
		retVal.put("fallbackTransport", new JSONString(fallbackTransport));
		return retVal;
	}

	public void setService(String service) {
		this.service = service;
	}

	public void setChannelId(String channelId) {
		this.channelId = channelId;
	}

	public void setTransport(String transport) {
		this.transport = transport;
	}

	public void setFallbackTransport(String fallbackTransport) {
		this.fallbackTransport = fallbackTransport;
	}
	
	public void setMessageHandler(IAtmosphereMessageHandler handler) {
        this.messageHandler = handler;
    }
	
	public IAtmosphereMessageHandler getMessageHandler() {
		return this.messageHandler;
	}
}
